﻿using Infragistics.Controls.Editors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamComboEditorSelectAllCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();
        }

        bool fromOtherDeselection = false;
        private void XamComboEditor_SelectionChanged(object sender, Infragistics.Controls.Editors.SelectionChangedEventArgs e)
        {
            XamComboEditor combo = sender as XamComboEditor;

            if (e.AddedItems != null)
            {
                if (e.AddedItems.Count != 0)
                {
                    if (((SampleData)e.AddedItems[0]).Label.Contains("Select All"))
                    {
                        combo.Items.ToList().ForEach(cei => cei.IsSelected = true);
                    }
                    else
                    {
                        if (combo.Items.Where(cei => cei.IsSelected).Count() == combo.Items.Count - 1)
                        {
                            combo.Items.ToList().ForEach(cei => cei.IsSelected = true);
                        }
                    }
                }
            }

            if (e.RemovedItems != null)
            {
                if (e.RemovedItems.Count != 0)
                {
                    if (!((SampleData)e.RemovedItems[0]).Label.Contains("Select All"))
                    {
                        if (combo.Items[combo.Items.Count - 1].IsSelected)
                        {
                            //This is here because the following combo.Items[...] call will fire this SelectionChanged event again.
                            fromOtherDeselection = true;
                            combo.Items[combo.Items.Count - 1].IsSelected = false;
                        }
                    }
                    else
                    {
                        if (fromOtherDeselection)
                        {
                            fromOtherDeselection = false;
                        }
                        else
                        {
                            combo.Items.ToList().ForEach(cei => cei.IsSelected = false);
                        }                        
                    }
                }
            }
        }
    }
}
